
package com.fractalite.hermes.teldar.cfg;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.StringReader;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.soap.MessageFactory;
import javax.xml.soap.SOAPBody;
import javax.xml.soap.SOAPMessage;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.apache.camel.Exchange;
import org.apache.camel.ExchangePattern;
import org.apache.camel.Processor;
import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.converter.jaxb.JaxbDataFormat;
import org.apache.camel.model.language.JXPathExpression;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

import com.fractalite.hermes.services.stay.StayRouteBuilder;
import com.fractalite.hermes.teldar.Marshaller.MarshallingJAXB;
import com.fractalite.hermes.teldar.Marshaller.UnmarshallingJAXB;
import com.fractalite.hermes.teldar.parsers.ParseAddBookingTeldar;
import com.fractalite.hermes.teldar.parsers.ParseConfirmBookResponse;
import com.fractalite.hermes.teldar.parsers.ParseHoteldetailsResponse;
import com.fractalite.hermes.teldar.parsers.ParseTeldarHotelsPriceResponse;
import com.fractalite.hermes.teldar.services.ConfirmBookTeldarRequest;
import com.fractalite.hermes.teldar.services.GetHotelDetailsRequest;
import com.fractalite.hermes.teldar.services.HotelQuotesRequest;
import com.fractalite.hermes.teldar.services.PreBookingTeldarRequest;
import com.fractalite.hermes.teldar.services.SearchTeldarHotelPriceRequest;
import com.fractalite.models.commerce.QuoteTemplate;
import com.fractalite.models.commerce.RequestForQuote;
import com.fractalite.models.travel.stay.Hotel;
import com.fractalite.models.travel.stay.HotelStay;
import com.fractalite.models.travel.stay.StaySearchResults;
import com.gekko_holding.webservice.v2_4.CityBean;
import com.gekko_holding.webservice.v2_4.Facility;
import com.gekko_holding.webservice.v2_4.GeoLocalization;
import com.gekko_holding.webservice.v2_4.GetHotelDetailsResponse;
import com.gekko_holding.webservice.v2_4.HotelAvailability;
import com.gekko_holding.webservice.v2_4.HotelAvailabilityResponse;
import com.gekko_holding.webservice.v2_4.HotelBean;
import com.gekko_holding.webservice.v2_4.HotelBean.Facilities;
import com.gekko_holding.webservice.v2_4.HotelBean.Images;
import com.gekko_holding.webservice.v2_4.HotelChain;
import com.gekko_holding.webservice.v2_4.ImageUrl;

public class TeldarRouteBuilder extends RouteBuilder {
	public static final String EP_SEARCH = "teldar/hotel/search";
	public static final String EP_HOTEL_QUOTES = "teldar/hotel/quote";
	public static final String EP_HOTEL_ADDRESSE = "teldar/hotel/addresse";
	public static final String EP_HOTEL_INFO = "teldar/hotel/info";
	public static final String CHEK_AVAILABILITY = "teldar/hotel/chek";
	public static final String BOOK_HOTEL = "teldar/hotel/bookhotel";
	public static final String EP_HOTEL_QUOTE_CANCELLATION_POLICY = "teldar/hotel/hotelQuoteCancelleationFees";
	public static final String EP_CHARGE_CONDITIONS_BOOKING_LINE = "teldar/hotel/chargeConditionsBookingLine";
	public static final String EP_ORDER = "teldar/hotel/Order";
	public static final String EP_GET_ORDER = "teldar/hotel/getOrder";
	public static final String EP_BOOKING_CONFIRMATION = "teldar/hotel/bookingConfirmation";
	public static final String EP_CANCELLATION_FEES = "teldar/hotel/cancelleationFees";
	public static final String EP_CANCEL_ORDER = "teldar/hotel/cancelOrder";
	public static final String EP_MODIFY_ORDER = "teldar/hotel/modifyOrder";
	public static final String EP_MODIFY_ORDER_ITEM = "teldar/hotel/modifyOrderItem";
	public static final String EP_CANCEL_ORDER_ITEM = "teldar/hotel/cancelOrderItem";
	public static final String EP_SEARCH_ORDER = "teldar/hotel/searchOrder";
	public static final String EP_SEARCH_RESULT = "stay/searchResults";
	public static final String wsUrl = "http4://teldar.atlasvoyages.com/gekko-front/ws/v2_4/AvailabilityService";

//	public static final String wsUrl ="http4://teldar.atlasvoyages.com/gekko-front/ws/v2_4/AvailabilityService";
//	public static final String wsUrl ="https4://34.250.74.154:8082/search";
//	public static final String wsUrl = "https4://teldar.atlasvoyages.com/gekko-front/ws/v2_4/AvailabilityService";

//	public static final String wsUrl = "http4://api.infinitehotel.com/gekko-front/ws/v2_4/AvailabilityService";
//	public static final String wsUrl = "http4://api.infinitehotel.com/gekko-front/ws/v2_4/AvailabilityService";

//  public static final String wsUrl = "http4://hermes-scribe.fractalite.com/gekko-front/ws/v2_4/AvailabilityService";
//	public static final String WSURL_REF = "http4://hermes-scribe.fractalite.com/gekko-front/ws/v2_4/ReferentialService";

	public String status = "";
	// TEST

	// public static final String clientId ="atlasvoyages_test/xml";
	// public static final String password="RmsSj7tbKxUu";

	// PROD teldar

	public static final String clientId = "atlasvoyages/master/test";
	public static final String password = "p*TE*kH!e8$%dS";
	public static final String customerKey = "atlasvoyages/test";

	// PROD teldar
	// public static final String clientId = "atlasvoyages/xml";
	// public static final String password = "aPxsZ63NpyqPkEYs";

	org.apache.camel.spi.DataFormat jaxb = new org.apache.camel.converter.jaxb.JaxbDataFormat(
			"com.fractalite.hermes.teldar.api");

	private static final Logger logger = LoggerFactory.getLogger(TeldarRouteBuilder.class);

	private JaxbDataFormat hotelsDataFormat;

	private boolean test = false;
	// private static HashMap<String, HashMap<String, String>> hmap = new
	// HashMap<String, HashMap<String, String>>();

	/*
	 * public Object Convertion() throws JAXBException { JAXBContext jaxbContext
	 * =JAXBContext.newInstance(GetHotelDetailsResponse.class); Unmarshaller
	 * unmarshaller = jaxbContext.createUnmarshaller();
	 * 
	 * StringReader reader = new StringReader("xml string here");
	 * GetHotelDetailsResponse person = (GetHotelDetailsResponse)
	 * unmarshaller.unmarshal(reader); return person;
	 * 
	 * }
	 */

	// public static HashMap<String,String> BoardList = new
	// HashMap<String,String>();

	public TeldarRouteBuilder() {

		super();
	}

	/**
	 * Constructor specifying if the routeBuilder is ran as test on production,
	 * public endpoints are exposed through NMR component to enable inter bundle
	 * communication on test , public endpoints are exposed through Direct component
	 * (nmr testing is confusing)
	 *
	 * @param test true if test
	 */
	public TeldarRouteBuilder(boolean test) {

		super();
		this.test = test;
	}

	public static String soapMessageBodyContent(String message) throws Exception {
		// create message factory
		MessageFactory messageFactory = MessageFactory.newInstance();

		// converting string body to stream.
		InputStream responseInputStream = new ByteArrayInputStream(message.getBytes());

		// getting saop body stream to create soap message instance
		SOAPMessage soapMessage = messageFactory.createMessage(null, responseInputStream);

		// get the body
		SOAPBody soapBody = soapMessage.getSOAPBody();

		return convertToString(soapBody);
	}
	

	/**
	 * Notes on search and quote routes : Since teldar does not handle multi room
	 * type reservation, split/aggregate is used to make results per each room type
	 */
	@Override
	public void configure() throws Exception {
		String nmrOrDirect = (test) ? "direct:" : "nmr:";
	
		// XML Data Format
		JaxbDataFormat availabilityReqDF = new JaxbDataFormat();
		JAXBContext context = JAXBContext.newInstance(HotelAvailability.class);
		availabilityReqDF.setContext(context);

		JaxbDataFormat details = new JaxbDataFormat();
		JAXBContext contexts = JAXBContext.newInstance(GetHotelDetailsResponse.class);
		details.setContext(contexts);

		/*************** SearchHotelsPriceRequest ******************/

		JAXBContext hotelsContext = JAXBContext.newInstance(HotelAvailabilityResponse.class);
		hotelsDataFormat = new JaxbDataFormat();
		hotelsDataFormat.setContext(hotelsContext);
		hotelsDataFormat.setEncoding("UTF-8");

		from(nmrOrDirect + EP_SEARCH).routeId(EP_SEARCH).setExchangePattern(ExchangePattern.InOut)
				.log("Contacting search webservice !!!!!  ${body}").choice()
				// stop if morocco
				.when(new JXPathExpression("in/body/trip/content[1]/hotel/address/country/code = 'ma'")).otherwise()

				.process(new Processor() {

					@Override
					public void process(Exchange exchange) throws Exception {
						QuoteTemplate q = exchange.getIn().getMandatoryBody(QuoteTemplate.class);
						HotelStay hotelstay = q.getTrip().getContent(HotelStay.class).get(0);
						if (hotelstay.getGiatacode() == null || hotelstay.getGiatacode().getGekko_infinite() == null
								|| hotelstay.getGiatacode().getGekko_infinite().size() == 0)
							exchange.getIn().setHeader("teldaremtygiata", true);
						else
							exchange.getIn().setHeader("teldaremtygiata", false);
					}
				}).choice()
				// stop if code empty
				.when(header("teldaremtygiata").isEqualTo(true)).log("teldar Giata code is null")
				.removeHeader("teldaremtygiata").process(new Processor() {

					@Override
					public void process(Exchange exchange) throws Exception {
						StaySearchResults result = new StaySearchResults();
						result.setQuery(exchange.getIn().getBody(QuoteTemplate.class));
						exchange.getIn().setBody(result);
					}
				}).to(nmrOrDirect + StayRouteBuilder.EP_SEARCH_RESULT).stop()

				.otherwise().log("teldar Giata code is NOT null")
				.setHeader(Exchange.HTTP_METHOD, constant(org.apache.camel.component.http4.HttpMethods.POST))
				.setHeader(Exchange.CONTENT_TYPE, constant("application/xml"))
				.setHeader(Exchange.SOAP_ACTION, constant("")).process(new Processor() {

					@Override
					public void process(Exchange exchange) throws Exception {

						for (String h : exchange.getIn().getHeaders().keySet())
							logger.info("\n header before serach " + h + " : " + exchange.getIn().getHeader(h));
						exchange.setProperty("linkheader", exchange.getIn().getHeader("Link"));
						exchange.setProperty("hermessearchcompletionsize",
								exchange.getIn().getHeader("hermessearchcompletionsize"));
					}
				}).process(new SearchTeldarHotelPriceRequest()).bean(MarshallingJAXB.class, "marshallObject")
				.log("\n Request body content : \n ${body}").log("urlllll" + wsUrl)

				.to(wsUrl)// + "?throwExceptionOnFailure=false")
				.convertBodyTo(String.class, "ISO-8859-1").log("\n teldar response body --------------- : \n ${body}")
				.process(new Processor() {
					@Override
					public void process(Exchange exchange) throws Exception {
						exchange.getIn().setHeaders(new HashMap<String, Object>());
						exchange.getIn().setHeader("Link", exchange.getProperty("linkheader"));

						exchange.getIn().setHeader("hermessearchcompletionsize",
								exchange.getProperty("hermessearchcompletionsize"));

						soapMessageBodyContent(exchange.getIn().getBody(String.class));

						logger.info("unmarshledSoap" + soapMessageBodyContent(exchange.getIn().getBody(String.class)));

					}
				})

				/* Unmarshalling teldar response */
				.bean(UnmarshallingJAXB.class, "fromHotelAvailabilityResponse(${body})")
				// .bean(UnmarshallingJAXB.class)

				/* Converting teldar response. */

				.log("responsemarshllerrr --------------- : \n ${body}").process(new ParseTeldarHotelsPriceResponse())
				.end().to(nmrOrDirect + EP_SEARCH_RESULT);

		/***************** CityHotelRequest *******************/

		/*
		 * from(nmrOrDirect +
		 * EP_HOTEL_ADDRESSE).routeId(EP_HOTEL_ADDRESSE).setExchangePattern(
		 * ExchangePattern.InOut) .removeHeaders("*") .setHeader(Exchange.HTTP_METHOD,
		 * constant(org.apache.camel.component.http4.HttpMethods.POST))
		 * .setHeader(Exchange.CONTENT_TYPE, constant("application/xml"))
		 * .setHeader(Exchange.SOAP_ACTION, constant(""))
		 * .log("ConvertCcities : \n ${body}") .process(new
		 * CityHotelRequest()).log("ConvertCities : \n ${body}")
		 * .bean(MarshallingJAXB.class,
		 * "marshallObject").log("Marshalled body for cities : ${body}")
		 * 
		 * .to(WSURL_REF).convertBodyTo(String.class)
		 * 
		 * .log("Citie Response : \n " + body())
		 * 
		 * .bean(UnmarshallingJAXB.class, "fromGetCitiesResponse(${body})").process(new
		 * Processor() {
		 * 
		 * @Override public void process(Exchange exchange) throws Exception {
		 * exchange.getIn().setHeaders(new HashMap<String, Object>());
		 * 
		 * logger.info("contcity" + getCities(list1)); } })
		 * 
		 * .process(new ParserCityHotelResonse());
		 * 
		 * 
		 * 
		 */

		/***************** HotelQuotesRequest *******************/

		from(nmrOrDirect + EP_HOTEL_QUOTES).routeId(EP_HOTEL_QUOTES).setExchangePattern(ExchangePattern.InOut)
				
				
				.setHeader(Exchange.HTTP_METHOD, constant(org.apache.camel.component.http4.HttpMethods.POST))
				.setHeader(Exchange.CONTENT_TYPE, constant("application/xml"))
				.setHeader(Exchange.SOAP_ACTION, constant(""))

				.process(new HotelQuotesRequest()).process(new Processor() {

					@Override
					public void process(Exchange exchange) throws Exception {
						for (String h : exchange.getIn().getHeaders().keySet())
							logger.info("header before quote " + h + " :  " + exchange.getIn().getHeader(h));

					}
				})

				.bean(MarshallingJAXB.class, "marshallObject")
				// .log("Marshalled body for quotes : ${body}")
				.to(wsUrl)// + "?throwExceptionOnFailure=false")

				.convertBodyTo(String.class)

				.process(new Processor() {

					@Override
					public void process(Exchange exchange) throws Exception {
						exchange.getIn().setHeaders(new HashMap<String, Object>());
						logger.info("UnmashalledQuoteeeee response body : ---------- \n "
								+ soapMessageBodyContent(exchange.getIn().getBody(String.class)));
					}
				})


				.bean(UnmarshallingJAXB.class, "fromHotelAvailabilityResponse(${body})")

				.log("ResponseMarshllerQuote --------------- : \n ${body}")

				.process(new com.fractalite.hermes.teldar.parsers.ParserQuotesresponse());
				

		/***************** HotelDetailsInfo *******************/

		from(nmrOrDirect + EP_HOTEL_INFO).routeId(EP_HOTEL_INFO).setExchangePattern(ExchangePattern.InOut)
			
		
	
				.setHeader(Exchange.HTTP_METHOD, constant(org.apache.camel.component.http4.HttpMethods.POST))
				.setHeader(Exchange.CONTENT_TYPE, constant("application/xml"))
				.setHeader(Exchange.SOAP_ACTION, constant("")).process(new GetHotelDetailsRequest())

				.log("bodyDetailss : \n ${body}").bean(MarshallingJAXB.class, "marshallObject")

				.to(wsUrl + "?throwExceptionOnFailure=false")

				.convertBodyTo(String.class, "ISO-8859-1").log("ResponseDetails --------------- : \n ${body}")

				.process(new Processor() {

					@Override
					public void process(Exchange exchange) throws Exception {
						exchange.getIn().setHeaders(new HashMap<String, Object>());

						logger.info("ConvertionNodeDteails"
								+ ConvertionNode(soapMessageBodyContent(exchange.getIn().getBody(String.class))));

						exchange.getOut().setBody(
								ConvertionNode(soapMessageBodyContent(exchange.getIn().getBody(String.class))));

					}
				})

				// .bean(UnmarshallingJAXB.class, "fromGetDetailsResponse(${body})")
				// .bean(UnmarshallingJAXB.class)
				.removeHeader("camel*")
				.process(new ParseHoteldetailsResponse());



		/***************** PreBookingHotelRequest *******************/

		from(nmrOrDirect + EP_ORDER)
		.log("EP--PREORDER  ${body}")
	      //  from("timer://orderTimer?delay=6000&repeatCount=1")
				.routeId(EP_ORDER).setExchangePattern(ExchangePattern.InOut)
				.log("PreOrder webservice !!!!!  ${body}")
				.removeHeaders("*")
				.setHeader(Exchange.HTTP_METHOD, constant(org.apache.camel.component.http4.HttpMethods.POST))
				.setHeader(Exchange.CONTENT_TYPE, constant("application/xml"))
				.setHeader(Exchange.SOAP_ACTION, constant(""))

			     .log("headerss")
				.process(new PreBookingTeldarRequest())
				.bean(MarshallingJAXB.class, "marshallObject")
				.log("PreBookTeldar body --------------- : \n ${body}")

				.to(wsUrl)

				.convertBodyTo(String.class)
				.log("ResponsePreOrderBOok --------------- : \n ${body}")
				.process(new Processor() {

					@Override
					public void process(Exchange exchange) throws Exception {
						exchange.getIn().setHeaders(new HashMap<String, Object>());
						soapMessageBodyContent(exchange.getIn().getBody(String.class));

						logger.info("unmarshledSoapPreBOOK" + soapMessageBodyContent(exchange.getIn().getBody(String.class)));

					}
				})
     			.bean(UnmarshallingJAXB.class, "fromPreBookingInfoResponse1(${body})")
				.log("ResponseMarshllerPreOder --------------- : \n ${body}")
				.process(new ParseAddBookingTeldar())
				.log("ResponseParserBook ---------- : \n ${body}");
				
		
		
///////////////////EP_BOOKING_CONFIRMATION////////////////////////////
		

		from(nmrOrDirect + EP_BOOKING_CONFIRMATION)
		.log("EP----CONFIRMATION ${body}")
				// from("timer://orderTimer?delay=6000&repeatCount=1")
				.routeId(EP_BOOKING_CONFIRMATION)
				.setExchangePattern(ExchangePattern.InOut)
				.log("ConfirmOrder webservice !!!!!  ${body}")
				.removeHeaders("*")
				.setHeader(Exchange.HTTP_METHOD, constant(org.apache.camel.component.http4.HttpMethods.POST))
				.setHeader(Exchange.CONTENT_TYPE, constant("application/xml"))
				.setHeader(Exchange.SOAP_ACTION, constant(""))
				.process(new ConfirmBookTeldarRequest())
				.bean(MarshallingJAXB.class, "marshallObject")
				.log("ConfirmBookTeldarRequest Body --------------- : \n ${body}")
				.to(wsUrl)
				.convertBodyTo(String.class)
				.log("ConfirmBookTeldarRequest Response body --------------- : \n ${body}")

				.bean(UnmarshallingJAXB.class, "fromBookHotelResponse(${body})")
				.process(new ParseConfirmBookResponse());
		
		
		/***************** HotelChargeConditionsBookingRequest *******************/

		from(nmrOrDirect + EP_CANCELLATION_FEES).routeId(EP_CANCELLATION_FEES)
				.setExchangePattern(ExchangePattern.InOut);

		/***************** HotelQuotesCancellationPolicyRequest *******************/

		from(nmrOrDirect + EP_HOTEL_QUOTE_CANCELLATION_POLICY).routeId(EP_HOTEL_QUOTE_CANCELLATION_POLICY)
				.setExchangePattern(ExchangePattern.InOut);

		/***************** CancelBookingRequest *******************/

		from(nmrOrDirect + EP_CANCEL_ORDER).routeId(EP_CANCEL_ORDER).setExchangePattern(ExchangePattern.InOut);

	}

	private static GetHotelDetailsResponse ConvertionNode(String hoteldetail)
			throws ParserConfigurationException, SAXException, IOException, JAXBException, TransformerException {
		Logger logg = LoggerFactory.getLogger(TeldarRouteBuilder.class);
		// Document document = stringToXml(hoteldetail);
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder;
		builder = factory.newDocumentBuilder();
		Document document = builder.parse(new InputSource(new StringReader(hoteldetail)));
		Element rootElement = document.getDocumentElement();

		GetHotelDetailsResponse resp = new GetHotelDetailsResponse();

		NodeList nLhotelName = rootElement.getElementsByTagName("hotelName");

		Element elmnhotelName = (Element) nLhotelName.item(0);

		String hotelCode = "";
		NodeList nLhotelCodee = rootElement.getElementsByTagName("hotelCode");
		Element elmnhotelCodee = (Element) nLhotelCodee.item(0);
		if (elmnhotelCodee != null && elmnhotelCodee.getTextContent() != null) {
			hotelCode = elmnhotelCodee.getTextContent();
		}

		String hotelRating = "";
		NodeList nLhotelRating = rootElement.getElementsByTagName("hotelRating");
		Element elmnhotelRating = (Element) nLhotelRating.item(0);
		if (elmnhotelRating != null && elmnhotelRating.getTextContent() != null) {
			hotelRating = elmnhotelRating.getTextContent();
		}
		/*
		 * Node nLhotelRating = rootElement.getAttributeNode("hotelRating");
		 * 
		 * String hotelRating = nLhotelRating.getNodeValue();
		 */
		HotelChain htlChaine = new HotelChain();
		NodeList nLhotelChain = rootElement.getElementsByTagName("hotelChain");

		Element elmnhotelChain = (Element) nLhotelChain.item(0);
		if (elmnhotelChain != null && elmnhotelChain.getTextContent() != null) {
			String hotelChain = elmnhotelChain.getTextContent();
			htlChaine.setValue(hotelChain);
		}

		CityBean cityB = new CityBean();
		NodeList nLcity = rootElement.getElementsByTagName("city");

		Element elmncity = (Element) nLcity.item(0);
		Node nLCode = elmncity.getAttributeNode("code");

		String codeCity = nLCode.getNodeValue();
		cityB.setCode(codeCity);

		GeoLocalization geo = new GeoLocalization();
		NodeList nLgeoLocalization = rootElement.getElementsByTagName("geoLocalization");

		Element elmngeoLocalization = (Element) nLgeoLocalization.item(0);
		Node nLlatitude = elmngeoLocalization.getAttributeNode("latitude");
		double latitude = Double.valueOf(nLlatitude.getNodeValue().toString());
		Node nLlongitude = elmngeoLocalization.getAttributeNode("longitude");
		double longitude = Double.valueOf(nLlongitude.getNodeValue());
		geo.setLatitude(latitude);
		geo.setLongitude(longitude);

		NodeList nLaddress = rootElement.getElementsByTagName("address");

		Element elmnaddress = (Element) nLaddress.item(0);

		NodeList nLphone = rootElement.getElementsByTagName("phone");

		Element elmnphone = (Element) nLphone.item(0);

		NodeList nLfax = rootElement.getElementsByTagName("fax");

		Element elmnfax = (Element) nLfax.item(0);

		NodeList nLemail = rootElement.getElementsByTagName("email");

		Element elmnemail = (Element) nLemail.item(0);

		NodeList nLshortDescription = rootElement.getElementsByTagName("shortDescription");

		Element elmnshortDescription = (Element) nLshortDescription.item(0);

		NodeList nLthumbnailUrl = rootElement.getElementsByTagName("thumbnailUrl");

		Element elmnthumbnailUrl = (Element) nLthumbnailUrl.item(0);

		NodeList nLfacilities = rootElement.getElementsByTagName("facilities");
		Facilities fclt = new Facilities();
		for (int i = 0; i < nLfacilities.getLength(); i++) {
			Facility fac = new Facility();

			Element elmnfacilities = (Element) nLfacilities.item(i);
			NodeList nLfacility = elmnfacilities.getElementsByTagName("facility");
			Element elmnfacility = (Element) nLfacility.item(0);

			Node nLCodeFacilities = elmnfacility.getAttributeNode("code");

			for (int j = 0; j < nLfacility.getLength(); j++) {
				Element elmnFac = (Element) nLfacility.item(j);
				// String typeImage = elmnImage.getNodeValue();
				Node cd = elmnFac.getAttributeNode("code");

				String faci = cd.getNodeValue();
				String facivalue = elmnFac.getTextContent();

				Facility fct = new Facility();
				fct.setCode(faci);
				fct.setValue(facivalue);
				fclt.getFacility().add(fct);
			}
			String codeFacility = nLCodeFacilities.getNodeValue();

			fac.setCode(codeFacility);
			fclt.getFacility().add(fac);

		}

		NodeList nLimages = rootElement.getElementsByTagName("images");
		Images imges = new Images();
		List<ImageUrl> igs = new ArrayList<ImageUrl>();
		List<String> str = new ArrayList<String>();

		for (int i = 0; i < nLimages.getLength(); i++) {
			ImageUrl ig = new ImageUrl();
			Element elmnImages = (Element) nLimages.item(i);
			NodeList nLImage = elmnImages.getElementsByTagName("image");
			Element elmnfacility = (Element) nLImage.item(0);
			Node nLTypeImages = elmnfacility.getAttributeNode("type");

			for (int j = 0; j < nLImage.getLength(); j++) {
				Element elmnImage = (Element) nLImage.item(j);
				// String typeImage = elmnImage.getNodeValue();

				String urlImage = elmnImage.getTextContent();

				// ig.setType(typeImage);
				ig.setValue(urlImage);
				str.add(ig.getValue());
				// imges.getImage().add(j, ig);
				igs.add(ig);

				// logg.info("igggg63" + imges.getImage().get(j).getValue());

			}

		}

		for (int j = 0; j < str.size(); j++) {
			ImageUrl igt = new ImageUrl();
			igt.setValue(str.get(j));
			imges.getImage().add(igt);
		}

		// String strObject = result.getWriter().toString() ;
		String hotelName = elmnhotelName.getTextContent();
		String city = elmncity.getTextContent();
		String geoLocalization = elmngeoLocalization.getTextContent();
		String address = elmnaddress.getTextContent();
		String phone = elmnphone.getTextContent();
		String fax = "";
		String email = "";
		String shortDescription = "";
		String thumbnailUrl = "";

		if (elmnfax != null && elmnfax.getTextContent() != null)
			fax = elmnfax.getTextContent();

		if (elmnemail != null && elmnemail.getTextContent() != null)
			email = elmnemail.getTextContent();

		if (elmnshortDescription != null && elmnshortDescription.getTextContent() != null)
			shortDescription = elmnshortDescription.getTextContent();

		if (elmnthumbnailUrl != null && elmnthumbnailUrl.getTextContent() != null)
			thumbnailUrl = elmnthumbnailUrl.getTextContent();

		HotelBean htlB = new HotelBean();
		htlB.setHotelName(hotelName);
		htlB.setHotelCode(hotelCode);
		htlB.setHotelRating(hotelRating); //
		htlB.setHotelChain(htlChaine);
		htlB.setAddress(address);
		htlB.setFax(fax);

		htlB.setPhone(phone);
		htlB.setEmail(email);
		htlB.setGeoLocalization(geo);
		htlB.setFacilities(fclt);
		htlB.setImages(imges);
		htlB.setShortDescription(shortDescription);
		htlB.setThumbnailUrl(thumbnailUrl);
		htlB.setCity(cityB);

		resp.getHotel().add(htlB);

		return resp;
	}

	public static Document stringToXml(String line) throws ParserConfigurationException, SAXException, IOException {
		Logger logg = LoggerFactory.getLogger(TeldarRouteBuilder.class);

		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder = factory.newDocumentBuilder();
		Document document = builder.parse(new InputSource(new StringReader(line)));

		return document;
	}

//hotelreponse
	private static String convertToString(SOAPBody message) throws Exception {

		Document doc = message.extractContentAsDocument();
		Element rootElement = doc.getDocumentElement();
		NodeList nList11 = rootElement.getElementsByTagName("hotel");
		Node m = nList11.item(0);
		Element s = (Element) m;

		StringWriter sw = new StringWriter();
		TransformerFactory tf = TransformerFactory.newInstance();
		Transformer transformer = tf.newTransformer();
		transformer.setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "yes");
		transformer.setOutputProperty(OutputKeys.METHOD, "xml");
		transformer.setOutputProperty(OutputKeys.INDENT, "yes");
		transformer.setOutputProperty(OutputKeys.ENCODING, "UTF-8");
		transformer.transform(new DOMSource(rootElement), new StreamResult(sw));
		return sw.toString();

	}

}
