
package com.fractalite.hermes.teldar.services;

import java.text.ParseException;
import java.text.SimpleDateFormat;

import javax.xml.datatype.DatatypeConfigurationException;

import org.apache.camel.Exchange;
import org.apache.camel.InvalidPayloadException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import com.fractalite.hermes.teldar.Marshaller.MarshallingJAXB;
import com.fractalite.hermes.teldar.cfg.TeldarRouteBuilder;
import com.fractalite.models.commerce.QuoteTemplate;
import com.fractalite.models.travel.PaxType;
import com.fractalite.models.travel.Traveller;
import com.fractalite.models.travel.stay.HotelStay;
import com.fractalite.models.travel.stay.Occupancy2;
import com.fractalite.models.travel.stay.Room;
import com.gekko_holding.webservice.v2_4.AvailabilityCriteria;
import com.gekko_holding.webservice.v2_4.AvailabilityCriteria.RoomCriterias;
import com.gekko_holding.webservice.v2_4.Child;
import com.gekko_holding.webservice.v2_4.CustomerIdentification;
import com.gekko_holding.webservice.v2_4.DestinationCriteria;
import com.gekko_holding.webservice.v2_4.Facility;
import com.gekko_holding.webservice.v2_4.HotelAvailability;
import com.gekko_holding.webservice.v2_4.HotelCodeDestination;
import com.gekko_holding.webservice.v2_4.RoomPlan;
import com.gekko_holding.webservice.v2_4.RoomPlan.Children;


public class HotelQuotesRequest extends TeldarServices {

	protected static Logger logger = LoggerFactory.getLogger(HotelQuotesRequest.class);

	@Override
	public void process(Exchange exchange)
			throws InvalidPayloadException, ParseException, DatatypeConfigurationException {

	logger.trace("Invoking TELDARQuote SearchHotelsPriceRequest Processor.......");
	QuoteTemplate q = exchange.getIn().getMandatoryBody(QuoteTemplate.class);
//	exchange.setProperty("QuoteTemplate", q);
	HotelStay hotelstay = q.getTrip().getContent(HotelStay.class).get(0);
	exchange.setProperty("hermesquery", q);
	HotelAvailability teldarReq = getList(hotelstay);
	logger.info("End TELDAR QuoteRequest Processor......." + MarshallingJAXB.printXML(teldarReq));
	exchange.getIn().setBody(teldarReq, HotelAvailability.class);

}


public HotelAvailability getList(HotelStay hotelstay) throws ParseException, DatatypeConfigurationException
{
	HotelAvailability hotelavailability=new HotelAvailability();
	CustomerIdentification customeridentification=new CustomerIdentification();
	/*
	 * customeridentification.setClientId("atlasvoyages_test/xml");
	 * customeridentification.setPassword("RmsSj7tbKxUu");
	 */

	
	  customeridentification.setClientId(TeldarRouteBuilder.clientId);
	  customeridentification.setPassword(TeldarRouteBuilder.password);
	 
	AvailabilityCriteria avaCriteria = new AvailabilityCriteria();
	SimpleDateFormat formatter = new SimpleDateFormat("yyyy-mm-dd");
	
	hotelavailability.setIdentification(customeridentification);
	
	
   // GetHotelDetails gethoteldetails=new GetHotelDetails();
    
   DestinationCriteria destinationcriteria=new DestinationCriteria();
    
  //  HotelCodeDestination hotelcodedestination=new HotelCodeDestination();
//   hotelcodedestination.setCode(hotelstay.getHotel().getAddress().getLocality().getCode());      
  //  destinationcriteria.setHotel(hotelcodedestination);
    
  
    HotelCodeDestination hotel = new HotelCodeDestination();
    hotel.setCode(hotelstay.getHotel().getCode());
/*CityDestination citydestination=new CityDestination();
    citydestination.setCode("FRLIO");
  // citydestination.setCode("FRUIP");
    citydestination.setStandard("locode");
    destinationcriteria.setCity(citydestination);*/
   destinationcriteria.setHotel(hotel );
  
    avaCriteria.setDestinationCriteria(destinationcriteria);
    hotelavailability.setLanguage("EN");
    
    avaCriteria.setCheckIn(hotelstay.getCheckin().toString());
	avaCriteria.setCheckOut(hotelstay.getCheckout().toString());
    
   // avaCriteria.setCheckIn("2019-11-07");    
    //avaCriteria.setCheckOut("2019-11-09");

    

	Facility facility=new Facility();
	facility.getCode();
	facility.getValue();
	
    
  /*  GeoCodeDestination geocodedestination=new GeoCodeDestination();
    geocodedestination.setLatitude(0);
    geocodedestination.setLatitude(0);
    geocodedestination.setRange(null);
    destinationcriteria.setGeoCode(geocodedestination);
    
    PoiDestination poidestination=new PoiDestination();
    poidestination.setCode("");
    poidestination.setRange(null);
    destinationcriteria.setPoi(poidestination);
    */
  
    /*
    RoomOffer roomoffers=new RoomOffer();
    Iterator<Room> iterator = hotelstay.getRooms().iterator();
	while (iterator.hasNext()) {
		 RoomOffer roomoffer=new RoomOffer();	
		 Room chambre = new Room();
			int nbreOfAdult=0;
			int nbreOfInfant=0;
			List<Integer> age = new ArrayList<Integer>();
     
			chambre = iterator.next();
			for(Traveller traveller : chambre.getGuests())
				if(traveller.getClassification()==PaxType.ADULT)
					nbreOfAdult++;
				else if(traveller.getClassification()==PaxType.CHILD) {
						age.add(traveller.getAge().intValue());
					 }
					else
						nbreOfInfant++;
			roomoffer.setRoomIndex(1);
			roomoffer.setAdultsCount(nbreOfInfant);
			roomoffer.setAdultsCount(nbreOfAdult);
			roomoffers.getRoomType();
	}*/
	
	RoomCriterias crit = new RoomCriterias();

	//Room rooms = new Room();
	String roo = "";
	for (Room chambre : hotelstay.getRooms()) {
		//Log.info("rooooooooommm " +hotelstay.getRooms().size());
		

		Occupancy2 occupancy = new Occupancy2();
		RoomPlan roomoffers = new RoomPlan();
		
		int nbreOfAdult = 0;
		Children chlidren = new Children();
		for (Traveller traveller : chambre.getGuests()) {
			
			if (traveller.getClassification() == PaxType.ADULT)
				nbreOfAdult++;
			else if (traveller.getClassification() == PaxType.CHILD) 
				{
					Child child=new Child();
					child.setAge(traveller.getAge());
					chlidren.getChild().add(child);
				}

			}
		occupancy.setAdults(nbreOfAdult);
		roomoffers.setRoomType(roo);
		roomoffers.setAdultsCount(nbreOfAdult);
	    roomoffers.setChildren(chlidren);	
		roomoffers.getRoomType();
		crit.getRoomPlan().add(roomoffers);

	}
	
	avaCriteria.setRoomCriterias(crit);

	/*
	 * avaCriteria.setRoomCriterias(crit);
	 * Log.info("tsssscot "+avaCriteria.getRoomCriterias().getRoomPlan().size());
	 */

	hotelavailability.setAvailCriteria(avaCriteria);

	
	
	
	
	/*
	 * RoomCriterias roomingList = new RoomCriterias(); RoomPlan roomPlan = new
	 * RoomPlan(); roomPlan.setAdultsCount(2); roomPlan.setRoomType("DOUB");
	 * roomingList.getRoomPlan().add(roomPlan );
	 * 
	 * avaCriteria.setRoomCriterias(roomingList);
	 * hotelavailability.setLanguage("EN");
	 * hotelavailability.setAvailCriteria(avaCriteria);
	 */	
	

	return hotelavailability;

//	roomPlan.setAdultsCount(hotelstay.getTravellers().get(0).getClassification().equals(PaxType.ADULT));
	/*
	 * Children children = new Children(); Child child = new Child();
	 * child.setAge(5); children.getChild().add(child);
	 * roomPlan.setChildren(children );
	 */
	
	/*
	Children children = new Children();
	Child child = new Child();
	child.setAge(5);
	children.getChild().add(child);
	Child child2 = new Child();
	child2.setAge(1);
	children.getChild().add(child2);
		roomPlan.setChildren(children );*/
	



}
}