package com.fractalite.hermes.teldar.services;

import java.text.ParseException;
import java.text.SimpleDateFormat;

import javax.xml.datatype.DatatypeConfigurationException;

import org.apache.camel.Exchange;
import org.apache.camel.InvalidPayloadException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import com.fractalite.hermes.teldar.Marshaller.MarshallingJAXB;
import com.fractalite.hermes.teldar.cfg.TeldarRouteBuilder;
import com.fractalite.models.commerce.QuoteTemplate;
import com.fractalite.models.travel.PaxType;
import com.fractalite.models.travel.Traveller;
import com.fractalite.models.travel.stay.HotelStay;
import com.fractalite.models.travel.stay.Occupancy2;
import com.fractalite.models.travel.stay.Room;
import com.gekko_holding.webservice.v2_4.AvailabilityCriteria;
import com.gekko_holding.webservice.v2_4.AvailabilityCriteria.RoomCriterias;
import com.gekko_holding.webservice.v2_4.Child;
import com.gekko_holding.webservice.v2_4.CityDestination;
import com.gekko_holding.webservice.v2_4.CustomerIdentification;
import com.gekko_holding.webservice.v2_4.DestinationCriteria;
import com.gekko_holding.webservice.v2_4.GeoCodeDestination;
import com.gekko_holding.webservice.v2_4.HotelAvailability;
import com.gekko_holding.webservice.v2_4.HotelCodeDestination;
import com.gekko_holding.webservice.v2_4.HotelCodeListDestination;
import com.gekko_holding.webservice.v2_4.RoomPlan;
import com.gekko_holding.webservice.v2_4.RoomPlan.Children;


public class SearchTeldarHotelPriceRequest extends TeldarServices {

	protected static Logger logger = LoggerFactory.getLogger(SearchTeldarHotelPriceRequest.class);

	@Override
	public void process(Exchange exchange)
			throws InvalidPayloadException, ParseException, DatatypeConfigurationException {

		// logger.trace("\n Invoking ACCOR SearchHotelsPriceRequest Processor.......");
		QuoteTemplate q = exchange.getIn().getMandatoryBody(QuoteTemplate.class);
		HotelStay hotelstay = q.getTrip().getContent(HotelStay.class).get(0);
		exchange.setProperty("hermesquery", q);
		HotelAvailability accorReq = getList(hotelstay);
		logger.info("\n End ACCOR SearchHotelsPriceRequest Processor......." + MarshallingJAXB.printXML(accorReq));
		exchange.getIn().setBody(accorReq, HotelAvailability.class);

	}

	public HotelAvailability getList(HotelStay hotelstay) throws ParseException, DatatypeConfigurationException {
		HotelAvailability hotelavailability = new HotelAvailability();
		CustomerIdentification customeridentification = new CustomerIdentification();
		/*
		 * customeridentification.setClientId("atlasvoyages/xml");
		 * customeridentification.setPassword("9mz%3h/DYV");
		 */

		customeridentification.setClientId(TeldarRouteBuilder.clientId);
		customeridentification.setPassword(TeldarRouteBuilder.password);

		AvailabilityCriteria avaCriteria = new AvailabilityCriteria();
		SimpleDateFormat formatter = new SimpleDateFormat("yyyy-mm-dd");

		hotelavailability.setIdentification(customeridentification);

		// GetHotelDetails gethoteldetails=new GetHotelDetails();

		/*
		 * DestinationCriteria destinationcriteria = new DestinationCriteria();
		 * 
		 * HotelCodeDestination hotelcodedestination=new HotelCodeDestination();
		 * hotelcodedestination.setCode(hotelstay.getHotel().getAddress().getLocality().
		 * getCode()); destinationcriteria.setHotel(hotelcodedestination);
		 */
		DestinationCriteria destinationcriteria = new DestinationCriteria();
		// CityDestination citydestination = new CityDestination();
		// citydestination.setCode(hotelstay.getHotel().getAddress().getLocality().getCode());
		// logger.info("codeeee"+hotelstay.getHotel().getAddress().getLocality().getCode());

		/*
		 * citydestination.setCode("FRLIO"); citydestination.setStandard("locode");
		 * destinationcriteria.setCity(citydestination);
		 */
		String desCode = hotelstay.getHotel().getAddress().getLocality().getCode();
		logger.info("loccccc" + desCode);
		if (desCode.contains("geo-")) {
			String[] geos = desCode.split("-");
			GeoCodeDestination geo = new GeoCodeDestination();
			geo.setLatitude(Double.parseDouble(geos[2]));
			geo.setLongitude(Double.parseDouble(geos[2]));
			geo.setRange(Double.parseDouble("2"));
			destinationcriteria.setGeoCode(geo);
			avaCriteria.setDestinationCriteria(destinationcriteria);

		} else {
			// Search By hotels codes

			HotelCodeListDestination hotelsList = new HotelCodeListDestination();
			//if(hotelstay.getGiatacode() == null || hotelstay.getGiatacode().getGekko_infinite() == null  || hotelstay.getGiatacode().getGekko_infinite().size() == 0)
		//	d
			for (String hotelcodes : hotelstay.getGiatacode().getGekko_infinite()) {
				String[] codes = hotelcodes.split("-");
				String supplierCode = codes[0];
				String giataCode = codes[1];
				HotelCodeDestination hcode = new HotelCodeDestination();
				hcode.setCode(supplierCode);
				hotelsList.getHotel().add(hcode);
			}

			destinationcriteria.setHotels(hotelsList);
			avaCriteria.setDestinationCriteria(destinationcriteria);
		}
		// hotelstay.getLocation().getCode();

		hotelavailability.setLanguage("EN");

		// logger.info("chekout is" +hotelstay.getCheckin());
		avaCriteria.setCheckIn(hotelstay.getCheckin().toString());
		avaCriteria.setCheckOut(hotelstay.getCheckout().toString());
		// hotelavailability.setAvailCriteria(avaCriteria);

		/*
		 * avaCriteria.setCheckIn("2019-11-07"); avaCriteria.setCheckOut("2019-11-09");
		 */

		/*
		 * Facility facility = new Facility(); facility.getCode(); facility.getValue();
		 */

		/*
		 * GeoCodeDestination geocodedestination=new GeoCodeDestination();
		 * destinationcriteria.setGeoCode(geocodedestination);
		 * 
		 * PoiDestination poidestination=new PoiDestination();
		 * poidestination.setCode(""); poidestination.setRange(null);
		 * destinationcriteria.setPoi(poidestination);
		 */
		RoomCriterias crit = new RoomCriterias();

		// Room rooms = new Room();
		String roo = "";
		for (Room chambre : hotelstay.getRooms()) {
			// Log.info("rooooooooommm " +hotelstay.getRooms().size());

			Occupancy2 occupancy = new Occupancy2();
			RoomPlan roomoffers = new RoomPlan();

			int nbreOfAdult = 0;
			Children chlidren = new Children();
			for (Traveller traveller : chambre.getGuests()) {

				if (traveller.getClassification() == PaxType.ADULT)
					nbreOfAdult++;
				else if (traveller.getClassification() == PaxType.CHILD) {
					Child child = new Child();
					child.setAge(traveller.getAge());
					chlidren.getChild().add(child);
				}

			}
			occupancy.setAdults(nbreOfAdult);
			roomoffers.setRoomType(roo);
			roomoffers.setAdultsCount(nbreOfAdult);
			roomoffers.setChildren(chlidren);
			roomoffers.getRoomType();
			crit.getRoomPlan().add(roomoffers);

		}

		avaCriteria.setRoomCriterias(crit);

		hotelavailability.setAvailCriteria(avaCriteria);

		/*
		 * RoomCriterias roomingList = new RoomCriterias(); RoomPlan roomPlan = new;
		 * RoomPlan(); roomPlan.setAdultsCount(2); roomPlan.setRoomType("DOUB");
		 * roomingList.getRoomPlan().add(roomPlan );
		 */

		/* avaCriteria.setRoomCriterias(roomingList); */
		/* hotelavailability.setLanguage("EN"); */

		return hotelavailability;

		// roomPlan.setAdultsCount(hotelstay.getTravellers().get(0).getClassification().equals(PaxType.ADULT));
		/*
		 * Children children = new Children(); Child child = new Child();
		 * child.setAge(5); children.getChild().add(child);
		 * roomPlan.setChildren(children );
		 */

		/*
		 * Children children = new Children(); Child child = new Child();
		 * child.setAge(5); children.getChild().add(child); Child child2 = new Child();
		 * child2.setAge(1); children.getChild().add(child2);
		 * roomPlan.setChildren(children );
		 */

	}

}
